 // just error code comments ripped from ddraw.h

#include <ddraw.h>

const char* DDErr( HRESULT hResult )
{
	switch( hResult ) 
	{
	case DDERR_ALREADYINITIALIZED:
		return "DDERR_ALREADYINITIALIZED: This object is already initialized.";
	case DDERR_CANNOTATTACHSURFACE:
		return "DDERR_CANNOTATTACHSURFACE: This surface can not be attached to the requested surface.";
	case DDERR_CANNOTDETACHSURFACE:
		return "DDERR_CANNOTDETACHSURFACE: This surface can not be detached from the requested surface.";
	case DDERR_CURRENTLYNOTAVAIL:
		return "DDERR_CURRENTLYNOTAVAIL: Support is currently not available.";
	case DDERR_EXCEPTION:
		return "DDERR_EXCEPTION: An exception was encountered while performing the requested operation.";
	case DDERR_GENERIC:
		return "DDERR_GENERIC: Generic failure.";
	case DDERR_HEIGHTALIGN:
		return "DDERR_HEIGHTALIGN: Height of rectangle provided is not a multiple of reqd alignment.";
	case DDERR_INCOMPATIBLEPRIMARY:
		return "DDERR_INCOMPATIBLEPRIMARY: Unable to match primary surface creation request with existing primary surface.";
	case DDERR_INVALIDCAPS:
		return "DDERR_INVALIDCAPS: One or more of the caps bits passed to the callback are incorrect.";
	case DDERR_INVALIDCLIPLIST:
		return "DDERR_INVALIDCLIPLIST: DirectDraw does not support provided Cliplist.";
	case DDERR_INVALIDMODE:
		return "DDERR_INVALIDMODE: DirectDraw does not support the requested mode.";
	case DDERR_INVALIDOBJECT:
		return "DDERR_INVALIDOBJECT: DirectDraw received a pointer that was an invalid DIRECTDRAW object.";
	case DDERR_INVALIDPARAMS:
		return "DDERR_INVALIDPARAMS: One or more of the parameters passed to the callback function are incorrect.";
	case DDERR_INVALIDPIXELFORMAT:
		return "DDERR_INVALIDPIXELFORMAT: Pixel format was invalid as specified";
	case DDERR_INVALIDRECT:
		return "DDERR_INVALIDRECT: Rectangle provided was invalid.";
	case DDERR_LOCKEDSURFACES:
		return "DDERR_LOCKEDSURFACES: Operation could not be carried out because one or more surfaces are locked.";
	case DDERR_NO3D:
		return "DDERR_NO3D: There is no 3D present.";
	case DDERR_NOALPHAHW:
		return "DDERR_NOALPHAHW: Operation could not be carried out because there is no alpha accleration hardware present or available.";
	case DDERR_NOSTEREOHARDWARE:
		return "DDERR_NOSTEREOHARDWARE: Operation could not be carried out because there is no stereo hardware present or available.";
	case DDERR_NOSURFACELEFT:
		return "DDERR_NOSURFACELEFT: Operation could not be carried out because there is no hardware present which supports stereo surfaces.";
	case DDERR_NOCLIPLIST:
		return "DDERR_NOCLIPLIST: No clip list available.";
	case DDERR_NOCOLORCONVHW:
		return "DDERR_NOCOLORCONVHW: Operation could not be carried out because there is no color conversion hardware present or available.";
	case DDERR_NOCOOPERATIVELEVELSET:
		return "DDERR_NOCOOPERATIVELEVELSET: Create function called without DirectDraw object method SetCooperativeLevel being called.";
	case DDERR_NOCOLORKEY:
		return "DDERR_NOCOLORKEY: Surface doesn't currently have a color key.";
	case DDERR_NOCOLORKEYHW:
		return "DDERR_NOCOLORKEYHW: Operation could not be carried out because there is no hardware support of the dest color key.";
	case DDERR_NODIRECTDRAWSUPPORT:
		return "DDERR_NODIRECTDRAWSUPPORT: No DirectDraw support possible with current display driver.";
	case DDERR_NOEXCLUSIVEMODE:
		return "DDERR_NOEXCLUSIVEMODE: Operation requires the application to have exclusive mode but the application does not have exclusive mode.";
	case DDERR_NOFLIPHW:
		return "DDERR_NOFLIPHW: Flipping visible surfaces is not supported.";
	case DDERR_NOGDI:
		return "DDERR_NOGDI: There is no GDI present.";
	case DDERR_NOMIRRORHW:
		return "DDERR_NOMIRRORHW: Mirror image operation not supported by present or available hardware.";
	case DDERR_NOTFOUND:
		return "DDERR_NOTFOUND: Requested item was not found";
	case DDERR_NOOVERLAYHW:
		return "DDERR_NOOVERLAYHW: No overlay hardware present or available.";
	case DDERR_OVERLAPPINGRECTS:
		return "DDERR_OVERLAPPINGRECTS: Source and destination rectangles are on the same surface and overlap each other.";
	case DDERR_NORASTEROPHW:
		return "DDERR_NORASTEROPHW: No appropriate raster op hardware present or available.";
	case DDERR_NOROTATIONHW:
		return "DDERR_NOROTATIONHW: No rotation hardware present or available.";
	case DDERR_NOSTRETCHHW:
		return "DDERR_NOSTRETCHHW: No hardware support for stretching";
	case DDERR_NOT4BITCOLOR:
		return "DDERR_NOT4BITCOLOR: DirectDrawSurface is not in 4 bit color palette and the requested operation requires 4 bit color palette.";
	case DDERR_NOT4BITCOLORINDEX:
		return "DDERR_NOT4BITCOLORINDEX: DirectDrawSurface is not in 4 bit color index palette and the requested operation requires 4 bit color index palette.";
	case DDERR_NOT8BITCOLOR:
		return "DDERR_NOT8BITCOLOR: DirectDraw Surface is not in 8 bit color mode and the requested operation requires 8 bit color.";
	case DDERR_NOTEXTUREHW:
		return "DDERR_NOTEXTUREHW: No texture mapping hardware present or available.";
	case DDERR_NOVSYNCHW:
		return "DDERR_NOVSYNCHW: No hardware support for vertical blank synchronized operations.";
	case DDERR_NOZBUFFERHW:
		return "DDERR_NOZBUFFERHW: No hardware support for zbuffer blting.";
	case DDERR_NOZOVERLAYHW:
		return "DDERR_NOZOVERLAYHW: "
			"Overlay surfaces could not be z layered based on their BltOrder because "
			"the hardware does not support z layering of overlays.";
	case DDERR_OUTOFCAPS:
		return "DDERR_OUTOFCAPS: The hardware needed for the requested operation has already been allocated.";
	case DDERR_OUTOFMEMORY:
		return "DDERR_OUTOFMEMORY: DirectDraw does not have enough memory to perform the operation.";
	case DDERR_OUTOFVIDEOMEMORY:
		return "DDERR_OUTOFVIDEOMEMORY: DirectDraw does not have enough memory to perform the operation.";
	case DDERR_OVERLAYCANTCLIP:
		return "DDERR_OVERLAYCANTCLIP: Hardware does not support clipped overlays.";
	case DDERR_OVERLAYCOLORKEYONLYONEACTIVE:
		return "DDERR_OVERLAYCOLORKEYONLYONEACTIVE: Can only have ony color key active at one time for overlays.";
	case DDERR_PALETTEBUSY:
		return "DDERR_PALETTEBUSY: Access to this palette is being refused because the palette is already locked by another thread.";
	case DDERR_COLORKEYNOTSET:
		return "DDERR_COLORKEYNOTSET: No src color key specified for this operation.";
	case DDERR_SURFACEALREADYATTACHED:
		return "DDERR_SURFACEALREADYATTACHED: This surface is already attached to the surface it is being attached to.";
	case DDERR_SURFACEALREADYDEPENDENT:
		return "DDERR_SURFACEALREADYDEPENDENT: This surface is already a dependency of the surface it is being made a dependency of.";
	case DDERR_SURFACEBUSY:
		return "DDERR_SURFACEBUSY: Access to this surface is being refused because the surface is already locked by another thread.";
	case DDERR_CANTLOCKSURFACE:
		return "DDERR_CANTLOCKSURFACE: "
				"Access to this surface is being refused because no driver exists which can supply a pointer to the surface. "
				"This is most likely to happen when attempting to lock the primary surface when no DCI provider is present. "
				"Will also happen on attempts to lock an optimized surface.";
	case DDERR_SURFACEISOBSCURED:
		return "DDERR_SURFACEISOBSCURED: Access to Surface refused because Surface is obscured.";
	case DDERR_SURFACELOST:
		return "DDERR_SURFACELOST: "  
				"Access to this surface is being refused because the surface is gone. "
				"The DIRECTDRAWSURFACE object representing this surface should "
				"have Restore called on it.";
	case DDERR_SURFACENOTATTACHED:
		return "DDERR_SURFACENOTATTACHED: The requested surface is not attached.";
	case DDERR_TOOBIGHEIGHT:
		return "DDERR_TOOBIGHEIGHT: Height requested by DirectDraw is too large.";
	case DDERR_TOOBIGSIZE:
		return "DDERR_TOOBIGSIZE: Size requested by DirectDraw is too large --  The individual height and width are OK.";
	case DDERR_TOOBIGWIDTH:
		return "DDERR_TOOBIGWIDTH: Width requested by DirectDraw is too large.";
	case DDERR_UNSUPPORTED:
		return "DDERR_UNSUPPORTED: Action not supported.";
	case DDERR_UNSUPPORTEDFORMAT:
		return "DDERR_UNSUPPORTEDFORMAT: Pixel format requested is unsupported by DirectDraw.";
	case DDERR_UNSUPPORTEDMASK:
		return "DDERR_UNSUPPORTEDMASK: Bitmask in the pixel format requested is unsupported by DirectDraw.";
	case DDERR_INVALIDSTREAM:
		return "DDERR_INVALIDSTREAM: The specified stream contains invalid data.";
	case DDERR_VERTICALBLANKINPROGRESS:
		return "DDERR_VERTICALBLANKINPROGRESS: Vertical blank is in progress.";
	case DDERR_WASSTILLDRAWING:
		return "DDERR_WASSTILLDRAWING: Informs DirectDraw that the previous Blt which is transfering information to or from this Surface is incomplete.";
	case DDERR_DDSCAPSCOMPLEXREQUIRED:
		return "DDERR_DDSCAPSCOMPLEXREQUIRED: The specified surface type requires specification of the COMPLEX flag.";
	case DDERR_XALIGN:
		return "DDERR_XALIGN: Rectangle provided was not horizontally aligned on reqd. boundary";
	case DDERR_INVALIDDIRECTDRAWGUID:
		return "DDERR_INVALIDDIRECTDRAWGUID: The GUID passed to DirectDrawCreate is not a valid DirectDraw driver identifier.";
	case DDERR_DIRECTDRAWALREADYCREATED:
		return "DDERR_DIRECTDRAWALREADYCREATED: A DirectDraw object representing this driver has already been created for this process.";
	case DDERR_NODIRECTDRAWHW:
		return "DDERR_NODIRECTDRAWHW: A hardware only DirectDraw object creation was attempted but the driver did not support any hardware.";
	case DDERR_PRIMARYSURFACEALREADYEXISTS:
		return "DDERR_PRIMARYSURFACEALREADYEXISTS: This process already has created a primary surface.";
	case DDERR_NOEMULATION:
		return "DDERR_NOEMULATION: Software emulation not available.";
	case DDERR_REGIONTOOSMALL:
		return "DDERR_REGIONTOOSMALL: Region passed to GetClipList is too small.";
	case DDERR_CLIPPERISUSINGHWND:
		return "DDERR_CLIPPERISUSINGHWND: An attempt was made to set a clip list for a clipper objec that is already monitoring an hwnd.";
	case DDERR_NOCLIPPERATTACHED:
		return "DDERR_NOCLIPPERATTACHED: No clipper object attached to surface object.";
	case DDERR_NOHWND:
		return "DDERR_NOHWND: Clipper notification requires an HWND or no HWND has previously been set as the CooperativeLevel HWND.";
	case DDERR_HWNDSUBCLASSED:
		return "DDERR_HWNDSUBCLASSED: HWND used by DirectDraw CooperativeLevel has been subclassed, this prevents DirectDraw from restoring state.";
	case DDERR_HWNDALREADYSET:
		return "DDERR_HWNDALREADYSET: The CooperativeLevel HWND has already been set. It can not be reset while the process has surfaces or palettes created.";
	case DDERR_NOPALETTEATTACHED:
		return "DDERR_NOPALETTEATTACHED: No palette object attached to this surface.";
	case DDERR_NOPALETTEHW:
		return "DDERR_NOPALETTEHW: No hardware support for 16 or 256 color palettes.";
	case DDERR_BLTFASTCANTCLIP:
		return "DDERR_BLTFASTCANTCLIP: A clipper object is attached to the source surface passed into a BltFast call.";
	case DDERR_NOBLTHW:
		return "DDERR_NOBLTHW: No hardware blitter.";
	case DDERR_NODDROPSHW:
		return "DDERR_NODDROPSHW: No DirectDraw ROP hardware.";
	case DDERR_OVERLAYNOTVISIBLE:
		return "DDERR_OVERLAYNOTVISIBLE: GetOverlayPosition was called on a hidden overlay.";
	case DDERR_NOOVERLAYDEST:
		return "DDERR_NOOVERLAYDEST: GetOverlayPosition is called on a overlay that UpdateOverlay has never been called on to establish a destionation.";
	case DDERR_INVALIDPOSITION:
		return "DDERR_INVALIDPOSITION: Position of the overlay on the destination is no longer legal.";
	case DDERR_NOTAOVERLAYSURFACE:
		return "DDERR_NOTAOVERLAYSURFACE: Overlay member function was called for a non-overlay surface.";
	case DDERR_EXCLUSIVEMODEALREADYSET:
		return "DDERR_EXCLUSIVEMODEALREADYSET: An attempt was made to set the cooperative level when it was already set to exclusive.";
	case DDERR_NOTFLIPPABLE:
		return "DDERR_NOTFLIPPABLE: An attempt has been made to flip a surface that is not flippable.";
	case DDERR_CANTDUPLICATE:
		return "DDERR_CANTDUPLICATE: Can't duplicate primary & 3D surfaces, or surfaces that are implicitly created.";
	case DDERR_NOTLOCKED:
		return "DDERR_NOTLOCKED: Surface was not locked.  An attempt to unlock a surface that was not locked at all, or by this process, has been attempted.";
	case DDERR_CANTCREATEDC:
		return "DDERR_CANTCREATEDC: "
				"Windows can not create any more DCs, or a DC was requested for a paltte-indexed "
				"surface when the surface had no palette AND the display mode was not palette-indexed "
				"(in this case DirectDraw cannot select a proper palette into the DC).";
	case DDERR_NODC:
		return "DDERR_NODC: No DC was ever created for this surface.";
	case DDERR_WRONGMODE:
		return "DDERR_WRONGMODE: This surface can not be restored because it was created in a different mode.";
	case DDERR_IMPLICITLYCREATED:
		return "DDERR_IMPLICITLYCREATED: This surface can not be restored because it is an implicitly created surface.";
	case DDERR_NOTPALETTIZED:
		return "DDERR_NOTPALETTIZED: The surface being used is not a palette-based surface";
	case DDERR_UNSUPPORTEDMODE:
		return "DDERR_UNSUPPORTEDMODE: The display is currently in an unsupported mode.";
	case DDERR_NOMIPMAPHW:
		return "DDERR_NOMIPMAPHW: Operation could not be carried out because there is no mip-map texture mapping hardware present or available.";
	case DDERR_INVALIDSURFACETYPE:
		return "DDERR_INVALIDSURFACETYPE: The requested action could not be performed because the surface was of the wrong type.";
	case DDERR_NOOPTIMIZEHW:
		return "DDERR_NOOPTIMIZEHW: Device does not support optimized surfaces, therefore no video memory optimized surfaces.";
	case DDERR_NOTLOADED:
		return "DDERR_NOTLOADED: Surface is an optimized surface, but has not yet been allocated any memory.";
	case DDERR_NOFOCUSWINDOW:
		return "DDERR_NOFOCUSWINDOW: Attempt was made to create or set a device window without first setting the focus window.";
	case DDERR_NOTONMIPMAPSUBLEVEL:
		return "DDERR_NOTONMIPMAPSUBLEVEL: Attempt was made to set a palette on a mipmap sublevel.";
	case DDERR_DCALREADYCREATED:
		return "DDERR_DCALREADYCREATED: A DC has already been return "";ed for this surface. Only one DC can be retrieved per surface.";
	case DDERR_NONONLOCALVIDMEM:
		return "DDERR_NONONLOCALVIDMEM: An attempt was made to allocate non-local video memory from a device that does not support non-local video memory."; 
	case DDERR_CANTPAGELOCK:
		return "DDERR_CANTPAGELOCK: The attempt to page lock a surface failed.";
	case DDERR_CANTPAGEUNLOCK:
		return "DDERR_CANTPAGEUNLOCK: The attempt to page unlock a surface failed.";
	case DDERR_NOTPAGELOCKED:
		return "DDERR_NOTPAGELOCKED: An attempt was made to page unlock a surface with no outstanding page locks.";
	case DDERR_MOREDATA:
		return "DDERR_MOREDATA: There is more data available than the specified buffer size could hold.";
	case DDERR_EXPIRED:
		return "DDERR_EXPIRED: The data has expired and is therefore no longer valid.";
	case DDERR_TESTFINISHED:
		return "DDERR_TESTFINISHED: The mode test has finished executing.";
	case DDERR_NEWMODE:
		return "DDERR_NEWMODE: The mode test has switched to a new mode.";
	case DDERR_D3DNOTINITIALIZED:
		return "DDERR_D3DNOTINITIALIZED: D3D has not yet been initialized."; 
	case DDERR_VIDEONOTACTIVE:
		return "DDERR_VIDEONOTACTIVE: The video port is not active.";
	case DDERR_NOMONITORINFORMATION:
		return "DDERR_NOMONITORINFORMATION: The monitor does not have EDID data.";
	case DDERR_NODRIVERSUPPORT:
		return "DDERR_NODRIVERSUPPORT: The driver does not enumerate display mode refresh rates.";
	case DDERR_DEVICEDOESNTOWNSURFACE:
		return "DDERR_DEVICEDOESNTOWNSURFACE: Surfaces created by one direct draw device cannot be used directly by another direct draw device.";
	case DDERR_NOTINITIALIZED:
		return "DDERR_NOTINITIALIZED: An attempt was made to invoke an interface member of a DirectDraw object created by CoCreateInstance() before it was initialized.";
	}
	return (char*)0;
}
	
